#define len_trim__(cad,len) ({                           integer _r=0,i;                           for(i=0; i<(len) && (cad)[i]; i++)                             if((cad)[i] != ' ') _r=i;                           _r+1; })
#define ceiling_(a) (myceil(*(a)))
#define myceil(a) (sizeof(a) == sizeof(float) ? ceilf(a) : ceil(a))
#include <math.h>
/*  -- translated by f2c (version 20200916).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#define __LAPACK_PRECISION_QUAD
#include "f2c.h"

/* Table of constant values */

static quadreal c_b2 = 1.;

/* > \brief \b DROTG */

/*  =========== DOCUMENTATION =========== */

/* Online html documentation available at */
/*            http://www.netlib.org/lapack/explore-html/ */

/*  Definition: */
/*  =========== */

/*       SUBROUTINE DROTG(DA,DB,C,S) */

/*       DOUBLE PRECISION C,DA,DB,S */


/* > \par Purpose: */
/*  ============= */
/* > */
/* > \verbatim */
/* > */
/* >    DROTG construct givens plane rotation. */
/* > \endverbatim */

/*  Arguments: */
/*  ========== */

/* > \param[in] DA */
/* > \verbatim */
/* >          DA is DOUBLE PRECISION */
/* > \endverbatim */
/* > */
/* > \param[in] DB */
/* > \verbatim */
/* >          DB is DOUBLE PRECISION */
/* > \endverbatim */
/* > */
/* > \param[out] C */
/* > \verbatim */
/* >          C is DOUBLE PRECISION */
/* > \endverbatim */
/* > */
/* > \param[out] S */
/* > \verbatim */
/* >          S is DOUBLE PRECISION */
/* > \endverbatim */

/*  Authors: */
/*  ======== */

/* > \author Univ. of Tennessee */
/* > \author Univ. of California Berkeley */
/* > \author Univ. of Colorado Denver */
/* > \author NAG Ltd. */

/* > \date November 2017 */

/* > \ingroup double_blas_level1 */

/* > \par Further Details: */
/*  ===================== */
/* > */
/* > \verbatim */
/* > */
/* >     jack dongarra, linpack, 3/11/78. */
/* > \endverbatim */
/* > */
/*  ===================================================================== */
void  qrotg_(quadreal *da, quadreal *db, quadreal *c__, 
	quadreal *s)
{
    /* System generated locals */
    quadreal d__1, d__2;

    /* Local variables */
    quadreal r__, z__, roe, scale;


/*  -- Reference BLAS level1 routine (version 3.8.0) -- */
/*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    -- */
/*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..-- */
/*     November 2017 */


/*  ===================================================================== */

    roe = *db;
    if (abs(*da) > abs(*db)) {
	roe = *da;
    }
    scale = abs(*da) + abs(*db);
    if (scale == 0.) {
	*c__ = 1.;
	*s = 0.;
	r__ = 0.;
	z__ = 0.;
    } else {
/* Computing 2nd power */
	d__1 = *da / scale;
/* Computing 2nd power */
	d__2 = *db / scale;
	r__ = scale * M(sqrt)(d__1 * d__1 + d__2 * d__2);
	r__ = d_sign(&c_b2, &roe) * r__;
	*c__ = *da / r__;
	*s = *db / r__;
	z__ = 1.;
	if (abs(*da) > abs(*db)) {
	    z__ = *s;
	}
	if (abs(*db) >= abs(*da) && *c__ != 0.) {
	    z__ = 1. / *c__;
	}
    }
    *da = r__;
    *db = z__;
    return;
} /* qrotg_ */

